package com.zteits.irain.portal.web.govclouds;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import com.alibaba.fastjson.JSONObject;
import com.clouds.common.web.BizController;
import com.clouds.common.web.vo.BizResultVO;
import com.zteits.clouds.api.apibase.bean.BizResult;
import com.zteits.clouds.api.apibase.bean.PageBean;
import com.zteits.clouds.api.dto.govclouds.dto.ParkingCountForTypeDTO;
import com.zteits.clouds.api.dto.govclouds.dto.ParkingTrackDTO;
import com.zteits.clouds.api.dto.govclouds.param.QueryParkingCountRequest;
import com.zteits.clouds.api.dto.govclouds.param.QueryParkingTrackRequest;
import com.zteits.clouds.api.service.govclouds.ParkPreferenceService;
import com.zteits.irain.portal.vo.govclouds.ParkingBusiCircleForTypeVO;
import com.zteits.irain.portal.vo.govclouds.ParkingCountForTypeVO;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
/**
 * 政府云平台--->数据分析--->停车轨迹.<br/>
 * 
 * Copyright: Copyright (c) 2017  zteits
 * 
 * @ClassName: ParkingContrailController.java
 * @Description: 
 * @version: v1.0.0
 * @author: wangfs
 * @date: 2017年7月13日   上午9:36:52 
 * Modification History:
 * Date             Author          Version            Description
 *---------------------------------------------------------*
 * 2017年7月13日      wangfs           v1.0.0               创建
 */
@Api(value = "政府云平台--->数据分析--->停车轨迹", description = "政府云平台--->数据分析--->停车轨迹")
@Controller
@RequestMapping("/parkingContrail")
public class ParkingContrailController extends BizController{

	private static final  Logger logger = LoggerFactory.getLogger(ParkingContrailController.class);
	@Autowired
	private ParkPreferenceService parkPreferenceService;
	
	@ApiOperation("停车编好->饼图")
	@PostMapping("/parkingCountForPlType")
	@ResponseBody
	public BizResultVO<List<ParkingCountForTypeVO>> parkingCountForPlType(@RequestBody QueryParkingCountRequest parkingCountRequest,HttpServletRequest request, HttpServletResponse response) throws Exception{
		BizResult<List<ParkingCountForTypeVO>> result = new  BizResult<List<ParkingCountForTypeVO>>();
		List<ParkingCountForTypeVO> list = new  ArrayList<ParkingCountForTypeVO>();
		logger.info("---begin停车轨迹-->停车编好->饼图Controller,入参＝"+JSONObject.toJSON(parkingCountRequest));
		BizResult<List<ParkingCountForTypeDTO>> bizResult =parkPreferenceService.queryParkingCountForPlType(parkingCountRequest);
		//int sumCurrentParkCount = 0;
		if(bizResult != null && !CollectionUtils.isEmpty(bizResult.getData())){
			for(ParkingCountForTypeDTO dto:bizResult.getData()){
				if(dto != null){
					//sumCurrentParkCount+= dto.getCurrentParkCount();
					ParkingCountForTypeVO parkingCountForTypeVO = new ParkingCountForTypeVO();
					BeanUtils.copyProperties(dto, parkingCountForTypeVO);
					list.add(parkingCountForTypeVO);
				}
			}
			
		}
		result.setErrCode(bizResult.getErrCode());
		result.setErrMsg(bizResult.getErrMsg());
		result.setData(list);
		logger.info("---begin停车轨迹-->停车编好->饼图Controller,结果＝"+result);
		
		return new BizResultVO<List<ParkingCountForTypeVO>>(result);
	}
	
	
	@ApiOperation("停车商圈属性对应的停车数量->柱状图")
	@PostMapping("/parkingCountForBusiCircle")
	@ResponseBody
	public BizResultVO<List<ParkingBusiCircleForTypeVO>> parkingCountForBusiCircle(@RequestBody QueryParkingCountRequest parkingCountRequest,HttpServletRequest request, HttpServletResponse response) throws Exception{
		BizResultVO<List<ParkingBusiCircleForTypeVO>> result = new  BizResultVO<List<ParkingBusiCircleForTypeVO>>();
		List<ParkingBusiCircleForTypeVO> list = new  ArrayList<ParkingBusiCircleForTypeVO>();
		logger.info("---begin停车轨迹-->停车商圈属性对应的停车数量->柱状图Controller,入参＝"+JSONObject.toJSON(parkingCountRequest));
		BizResult<List<ParkingCountForTypeDTO>> bizResult =parkPreferenceService.queryParkingBusiCircleForPlType(parkingCountRequest);
		if(bizResult != null && !CollectionUtils.isEmpty(bizResult.getData())){
			for(ParkingCountForTypeDTO dto:bizResult.getData()){
				if(dto != null){
					ParkingBusiCircleForTypeVO parkingBusiCircleForTypeVO = new ParkingBusiCircleForTypeVO();
					BeanUtils.copyProperties(dto, parkingBusiCircleForTypeVO);
					list.add(parkingBusiCircleForTypeVO);
				}
			}
		}
		result.setData(list);
		logger.info("---begin停车轨迹-->停车商圈属性对应的停车数量->柱状图Controller,结果＝"+result);
		return result;
	}
	
	@ApiOperation("停车车轨迹")
	@PostMapping("/queryParkingTrack")
	@ResponseBody
	public BizResultVO<ParkingTrackDTO> queryParkingTrack(@RequestBody QueryParkingTrackRequest queryParkingTrackRequest,HttpServletRequest request, HttpServletResponse response) throws Exception{
		BizResultVO<List<ParkingTrackDTO>> result = new  BizResultVO<List<ParkingTrackDTO>>();
		logger.info("---begin停车轨迹-->根据车牌查询该车的行车轨迹Controller,入参={}",JSONObject.toJSON(queryParkingTrackRequest));
		BizResult<ParkingTrackDTO> bizResult =parkPreferenceService.queryParkingTrack(queryParkingTrackRequest);
		logger.info("---begin停车轨迹-->根据车牌查询该车的行车轨迹Controller,结果={}",result);
		return new BizResultVO<ParkingTrackDTO>(bizResult);
	}
	
	
	
	
	
}















